/**
 * An abort error class that extends error
 */
export declare class AbortError extends Error {
    type: string;
    code: string | string;
    constructor(message?: string, code?: string);
}
export interface RaceSignalOptions {
    /**
     * The message for the error thrown if the signal aborts
     */
    errorMessage?: string;
    /**
     * The code for the error thrown if the signal aborts
     */
    errorCode?: string;
}
/**
 * Race a promise against an abort signal
 */
export declare function raceSignal<T>(promise: Promise<T>, signal?: AbortSignal, opts?: RaceSignalOptions): Promise<T>;
//# sourceMappingURL=index.d.ts.map